
from constants import *

# CPU side - really these are external ports
add(Write("cpu_address", size=CPU_LEFT + 1)) # in std_logic_vector ( CPU_LEFT downto 0 );
add(Write("cpu_data_in", size=DATA_LEFT + 1)) # in std_logic_vector ( DATA_LEFT downto 0 );
# cpu_data_in is also used for "size" and "reference in"
add(Read("cpu_data_out", size=DATA_LEFT + 1)) # out std_logic_vector ( DATA_LEFT downto 0 );
# cpu_data_out is also used for "reference out"
add(Write("cpu_copy_loc", size=SP_LEFT + 1)) # in std_logic_vector ( SP_LEFT downto 0 );
add(Write("cpu_size", size=SP_LEFT + 1)) # in std_logic_vector ( SP_LEFT downto 0 );
add(Write("cpu_ben", size=4)) # in std_logic_vector ( 3 downto 0 );
add(Write("cpu_write", size=0)) # in std_logic; -- in 
add(Write("cpu_read", size=0)) # in std_logic; -- in 
add(Write("cpu_open", size=0)) # in std_logic; -- in 
add(Write("cpu_close", size=0)) # in std_logic; -- in 
add(Write("cpu_read_only", size=0)) # in std_logic; -- in 
add(Read("cpu_ack", size=0)) # out std_logic; -- out 
# Add Data LMB interface here
# Control lines from smmu to IPIF
add(Read("mst_cntl_rd_req", size=0)) # out std_logic ;
add(Read("mst_cntl_wr_req", size=0)) # out std_logic ;
add(Read("mst_cntl_bus_lock", size=0)) # out std_logic ;
add(Read("mst_cntl_burst", size=0)) # out std_logic ;
add(Read("mst_ip2bus_addr", size=CPU_LEFT + 1)) # out std_logic_vector ( CPU_LEFT downto 0 ) ;
add(Read("mst_ip2bus_be", size=16)) # out std_logic_vector ( 15 downto 0 ) ;
add(Read("mst_xfer_length", size=12)) # out std_logic_vector ( 11 downto 0 ) ;
add(Read("mst_go", size=0)) # out std_logic ;
# Status lines from IPIF to smmu
add(Write("mst_cmd_sm_set_done", size=0)) # in std_logic ;
add(Write("mst_cmd_sm_set_error", size=0)) # in std_logic ;
add(Write("mst_cmd_sm_set_timeout", size=0)) # in std_logic ;
add(Write("mst_cmd_sm_busy", size=0)) # in std_logic ;
add(Write("mst_cmd_sm_clr_go", size=0)) # in std_logic ;
# Data interface
add(Write("output_next", size=0)) # in std_logic ;
add(Write("input_next", size=0)) # in std_logic ;
add(Read("data_output", size=DATA_LEFT + 1)) # out std_logic_vector ( DATA_LEFT downto 0 ) ;
add(Write("data_input", size=DATA_LEFT + 1)) # in std_logic_vector ( DATA_LEFT downto 0 ) ;
# Only service addresses matching this:
add(Write("match_mask", size=CPU_LEFT - ACTIVE_LEFT)) 
add(Write("reset", size=0)) # in std_logic ) ;

# Debugger stuff
add(Read("dbg_cpu_side_address", size = SP_LEFT + 1))
add(Read("dbg_bus_side_address", size = SP_LEFT + 1))
add(Read("dbg_cpu_side_data_in", size = DATA_LEFT + 1))
add(Read("dbg_cpu_side_data_out", size = DATA_LEFT + 1))
add(Read("dbg_bus_side_data_in", size = DATA_LEFT + 1))
add(Read("dbg_bus_side_data_out", size = DATA_LEFT + 1))
add(Read("dbg_cpu_side_write", size = 0))
add(Read("dbg_bus_side_write", size = 0))
add(Read("dbg_bus_side_cen", size = 0))

add(Read("dbg_match", size = 0))
add(Read("dbg_match_in_read_only_area", size = 0))
add(Read("dbg_miss", size = 0))
add(Read("dbg_hit", size = 0))

add(Read("dbg_read_only_update_pos", size = 4))
add(Read("dbg_update_burst_boundary", size = 0))
add(Read("dbg_match_address", size = CPU_LEFT + 1))

add(Read("dbg_code", size = 8))
add(Read("dbg_sp_cpu_valid", size = 0))
add(Read("dbg_slow_ack", size = 0))
add(Read("dbg_row_activation", size = NUM_ENTRIES))
add(Read("dbg_match_ref", size = REF_LEFT + 1))

add(Write("cache_active", size = 0))
add(Write("cpu_cache_set_perm", size = 0))
add(Write("cpu_cache_invalidate", size = 0))

add(Read("dbg_tag_address", size = SP_LEFT))
add(Read("dbg_permutation_in", size = SP_LEFT))
add(Read("dbg_cache_hit", size = 0))
add(Read("dbg_tag_in_16", size = 16))
add(Read("dbg_tag_out_16", size = 16))
add(Read("dbg_permutation_out", size = 16))

add(Read("dbg_cache_read", size = 0))
add(Read("dbg_cache_write", size = 0))
add(Read("dbg_enable_permutation", size = 0))

