/*
 * Scratchpad MMU - SMMU hardware driver for JPEG case study
 * Copyright (C) Jack Whitham 2009
 * http://www.jwhitham.org.uk/c/smmu.html
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation
 * (version 2.1 of the License only).
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */
#undef NDEBUG

#include <assert.h>
#include "drvif.h"
#include "xparameters.h"


unsigned read_only_remaining;

extern void * __rodata_start ;
extern void * _start ;

void Relocate ( void )
{
    unsigned    begin = (unsigned) & _start ;
    unsigned    end = (unsigned) & __rodata_start ;
    unsigned    size = end - begin ;
    unsigned    target = XPAR_DDR2_SDRAM_MPMC_BASEADDR ;
    unsigned    distance = target - begin ;

    if ( distance == 0 ) return ;

    while ( size != 0 )
    {
        (* ((char *) target )) = (* ((char *) begin)) ;
        target ++ ;
        begin ++ ;
        size -- ;
    }
    
    asm volatile (
        "addk  r15, r15, %0\n"
        "nop\n" : : "r"(distance) ) ;
}


